//----------------------------------------------------------------------------
// C main line
//----------------------------------------------------------------------------

#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules
#include "math.h"
#include "stdlib.h"
#include "string.h"

#pragma interrupt_handler Timer16
#pragma interrupt_handler ADC_Int

#define Laenge_Array 8
#define pi 3.14159265359

int LCD_WriteDouble(int Row, int Column, double Value);

int m;
int n;
int Status;

int Counter = 0;

// Array für die Spektralwerte
// 1. Dimension Kosinus
// 2. Dimension Sinus
// 3. Dimension Betrag des Spektrums
double Spektrum[3][Laenge_Array / 2];
double Messwerte[Laenge_Array] = {1, 1.707, 2, 1.707, 1, 0.293, 0, 0.293};

void main(void)
{
	M8C_EnableGInt;
	Timer16_EnableInt();  
  	Timer16_Start();  
	
	ADCINC_GetSamples(20);
	ADCINC_Start(ADCINC_HIGHPOWER); 
    PGA_Start(PGA_MEDPOWER);
	LCD_Start();                 
  
	for(m = 0; m < (Laenge_Array / 2); m++)
	{
		for(n = 0; n < Laenge_Array; n++)
		{
			Spektrum[0][m] = Spektrum[0][m] + Messwerte[n] * cos((2.0*pi*(double)m*(double)n)/(double)Laenge_Array);
			Spektrum[1][m] = Spektrum[1][m] + Messwerte[n] * sin((2.0*pi*(double)m*(double)n)/(double)Laenge_Array);
		}
		
		Spektrum[2][m] = (sqrt(pow(Spektrum[0][m], 2) + pow(Spektrum[1][m], 2))) / (double)Laenge_Array;
	}

	/*Status = LCD_WriteDouble(0, 0, Spektrum[2][0]);
	Status = LCD_WriteDouble(1, 0, Spektrum[2][1]);
	Status = LCD_WriteDouble(2, 0, Spektrum[2][2]);
	Status = LCD_WriteDouble(3, 0, Spektrum[2][3]);*/
	
	while(TRUE)
	{
		LCD_Position(0, 0);
		LCD_PrHexInt(Counter);
		LCD_Delay50uTimes(20);
	}
}

void Timer16(void)
{   
	return;
}

int LCD_WriteDouble(int Row, int Column, double Value)
{
	int Status;
	char* Dummy;
	
	LCD_Position(Row, Column);
	Dummy = ftoa(Value, &Status);
	LCD_PrString(Dummy);
	return Status;
}

void ADC_Int(void)
{
	Counter++;
}